Scriptname TissHeadTrackMCM extends SKI_ConfigBase

globalvariable property Key_Camera auto
globalvariable property Key_Pause auto
globalvariable property Key_Ecran auto
globalvariable property Key_Switch auto

globalvariable property CameraComplet auto
globalvariable property Camera180 auto
globalvariable property CameraHybride auto

globalvariable property EcranComplet auto
globalvariable property Ecran180 auto
globalvariable property EcranHybride auto

globalvariable property DisableWeapon auto
globalvariable property DisableNotifications auto
globalvariable property DisableFurniture auto
globalvariable property Invert360 auto
globalvariable property AutoDialogue auto

TissHeadTrack property TissHeadTrackQuest auto

Int OptionKeyCamera = 0
Int OptionKeyEcran = 0
Int OptionKeyPause = 0
Int OptionKeyHybride = 0
Int OptionKeySwitch = 0
bool OptionDisableWeapon = false
bool OptionDisableNotif = false
bool OptionDisableFurniture = false
bool OptionInvert360 = false
bool OptionAutoDialogue = false

Int CameraCompletID = 0
Int Camera180ID = 0
Int CameraHybrideID = 0

Int EcranCompletID = 0
Int Ecran180ID = 0
Int EcranHybrideID = 0

bool OptionCameraComplet = true
bool OptionCamera180 = false
bool OptionCameraHybride = false

bool OptionEcranComplet = true
bool OptionEcran180 = false
bool OptionEcranHybride = false


Int DisableWeaponID = 0
Int DisableNotifID = 0
Int Invertion360ID = 0
Int AutoDialogueID = 0

function OnPageReset(String page)
	SetCursorFillMode(TOP_TO_BOTTOM)
	SetCursorPosition(0)

	AddHeaderOption("Mode Suivre la camra", 0)

	OptionKeyCamera = AddKeyMapOption("Suivre la camra", Key_Camera.GetValue() as Int, 0)
	CameraCompletID = AddToggleOption("Complet", CameraComplet.GetValue() as Bool, 0)
	Camera180ID = AddToggleOption("180", Camera180.GetValue() as Bool, 0)
	CameraHybrideID = AddToggleOption("Hybride", CameraHybride.GetValue() as Bool, 0)

	SetCursorPosition(1)
	AddHeaderOption("Mode Regarder l'cran", 0)

	OptionKeyEcran = AddKeyMapOption("Regarder l'cran", Key_Ecran.GetValue() as Int, 0)
	EcranCompletID = AddToggleOption("Complet", EcranComplet.GetValue() as Bool, 0)
	Ecran180ID = AddToggleOption("180", Ecran180.GetValue() as Bool, 0)
	EcranHybrideID = AddToggleOption("Hybride", EcranHybride.GetValue() as Bool, 0)

	SetCursorPosition(12)
	AddHeaderOption("Autres touches", 0)

	OptionKeyPause = AddKeyMapOption("Garder la pose", Key_Pause.GetValue() as Int, 0)
	OptionKeySwitch = AddKeyMapOption("Changer de mode", Key_Switch.GetValue() as Int, 0)

	SetCursorPosition(13)
	AddHeaderOption("Autres options", 0)
	DisableWeaponID = AddToggleOption("Dsactiver quand les armes sont sorties", DisableWeapon.GetValue() as Bool, 0)
	DisableNotifID = AddToggleOption("Dsactiver les notifications", DisableNotifications.GetValue() as Bool, 0)
	Invertion360ID = AddToggleOption("360 Walk and Run Plus", Invert360.GetValue() as Bool, 0)
	AutoDialogueID = AddToggleOption("Verrouillage auto pendant les dialogues", AutoDialogue.GetValue() as Bool, 0)
	;SetCursorPosition(16)
	;;AddHeaderOption("Modes", 0)
	;;HybrideID = AddToggleOption("Hybride", DisableWeapon.GetValue() as Bool, 0)

endFunction

function OnOptionDefault(Int option)

	if option == OptionKeyCamera
		Key_Camera.SetValue(0)
		SetKeyMapOptionValue(OptionKeyCamera, 0, false)
	elseif option == OptionKeyEcran
		Key_Ecran.SetValue(0)
		SetKeyMapOptionValue(OptionKeyEcran, 0, false)
	elseif option == OptionKeyPause
		Key_Pause.SetValue(0)
		SetKeyMapOptionValue(OptionKeyPause, 0, false)
	elseif option == OptionKeySwitch
		Key_Switch.SetValue(0)
		SetKeyMapOptionValue(OptionKeySwitch, 0, false)
	endiF

	TissHeadTrackQuest.ReRegisterAllKeysForce()
		
endFunction

event OnOptionHighlight(int option)

	if option == OptionKeyCamera
		SetInfoText("La tte du joueur suit le mouvement de la camra, regardant dans la mme direction. Appuyez  nouveau sur la touche pour revenir en mode normal.")
	elseIf option == CameraCompletID
		SetInfoText("Avec cette option, le mode est toujours actif.")
	elseIf option == Camera180ID
		SetInfoText("Avec cette option, le mod alterne entre les modes \"Suivre la camra\" (quand la camra est derrire le joueur) et le mode normal (quand la camra est devant le joueur). ")
	elseIf option == CameraHybrideID
		SetInfoText("Avec cette option, le mod alterne entre les modes \"Suivre la camra\" (quand la camra est derrire le joueur) et \"Regarder l'cran\" (quand la camra est devant le joueur). ")
	elseIf option == OptionKeyEcran
		SetInfoText("La tte du joueur regarde en direction de l'cran, comme s'il nous regardait. Appuyez  nouveau sur la touche pour revenir en mode normal.")
	elseIf option == EcranCompletID
		SetInfoText("Avec cette option, le mode est toujours actif.")
	elseIf option == Ecran180ID
		SetInfoText("Avec cette option, le mod alterne entre les modes \"Regarder l'cran\" (quand la camra est devant le joueur) et le mode normal (quand la camra est derrire le joueur). ")
	elseIf option == EcranHybrideID
		SetInfoText("Avec cette option, le mod alterne entre les modes \"Suivre la camra\" (quand la camra est derrire le joueur) et \"Regarder l'cran\" (quand la camra est devant le joueur). ")
	elseIf option == OptionKeyPause
		SetInfoText("Activ aprs un des 2 modes prcdents, la tte du joueur se bloque dans la direction o elle se trouvait. Appuyez  nouveau sur la touche pour revenir au mode prcdent.")
	elseIf option == OptionKeySwitch
		SetInfoText("Permet de passer de manire cyclique les diffrents modes : \"Suivre la camra\" puis \"Regarder l'cran\" puis retour en mode normal. Un appui long sur cette touche active le mode \"Garder la pose\". Aprs quoi, un simple appui permet de revenir au mode prcdent.")
	elseIf option == DisableWeaponID
		SetInfoText("Dsactive tous les modes lorsque les armes sont sorties.")
	elseIf option == DisableNotifID
		SetInfoText("Dsactive les notifications lors des changements de modes.")
	elseif (option == Invertion360ID)
		SetInfoText("Option pour un meilleur fonctionnement avec le mod 360 Walk and Run Plus.")
	elseif (option == AutoDialogueID)
		SetInfoText("Quand le joueur parle  un PNJ, il le regarde automatiquement, mme si aucun mode n'est activ.")
	endIf


endEvent

function OnOptionSelect(Int option)

	if option == DisableWeaponID
		OptionDisableWeapon = !OptionDisableWeapon
		SetToggleOptionValue(DisableWeaponID, OptionDisableWeapon, false)
		DisableWeapon.SetValue(OptionDisableWeapon as Int)

	elseif option == DisableNotifID
		OptionDisableNotif = !OptionDisableNotif
		SetToggleOptionValue(DisableNotifID, OptionDisableNotif, false)
		DisableNotifications.SetValue(OptionDisableNotif as Int)

	elseif option == Invertion360ID
		OptionInvert360 = !OptionInvert360
		SetToggleOptionValue(Invertion360ID, OptionInvert360, false)
		Invert360.SetValue(OptionInvert360 as Int)

	elseif option == AutoDialogueID
		OptionAutoDialogue = !OptionAutoDialogue
		SetToggleOptionValue(AutoDialogueID, OptionAutoDialogue, false)
		AutoDialogue.SetValue(OptionAutoDialogue as Int)

	elseif option == CameraCompletID

		if OptionCameraComplet == False

			OptionCameraComplet = true
			OptionCamera180 =false
			OptionCameraHybride =false

		endIf

	elseif option == Camera180ID

		if OptionCamera180 == False

			OptionCameraComplet = False
			OptionCamera180 =true			
			OptionCameraHybride =false

		endIf

	elseif option == CameraHybrideID

		if OptionCameraHybride == False

			OptionCameraComplet = false
			OptionCamera180 =false
			OptionCameraHybride =true

		endIf

	elseif option == EcranCompletID

		if OptionEcranComplet == False

			OptionEcranComplet = true
			OptionEcran180 =false
			OptionEcranHybride =false

		endIf

	elseif option == Ecran180ID

		if OptionEcran180 == False

			OptionEcranComplet = False
			OptionEcran180 =true			
			OptionEcranHybride =false

		endIf

	elseif option == EcranHybrideID

		if OptionEcranHybride == False

			OptionEcranComplet = false
			OptionEcran180 =false
			OptionEcranHybride =true

		endIf

	endIf

	SetToggleOptionValue(CameraCompletID, OptionCameraComplet, false)
	CameraComplet.SetValue(OptionCameraComplet as Float)
	SetToggleOptionValue(Camera180ID, OptionCamera180, false)
	Camera180.SetValue(OptionCamera180 as Float)	
	SetToggleOptionValue(CameraHybrideID, OptionCameraHybride, false)
	CameraHybride.SetValue(OptionCameraHybride as Float)	

	SetToggleOptionValue(EcranCompletID, OptionEcranComplet, false)
	EcranComplet.SetValue(OptionEcranComplet as Float)
	SetToggleOptionValue(Ecran180ID, OptionEcran180, false)
	Ecran180.SetValue(OptionEcran180 as Float)	
	SetToggleOptionValue(EcranHybrideID, OptionEcranHybride, false)
	EcranHybride.SetValue(OptionEcranHybride as Float)	

	TissHeadTrackQuest.ChangeMCMMode()
	
endFunction

function OnOptionKeyMapChange(Int option, Int keyCode, String conflictControl, String conflictName)

	bool ok = true
	if conflictControl != ""
		String Avertissement
		if conflictName != ""
			Avertissement = "Cette touche est dj utilise :\n\"" + conflictControl + "\"\n(" + conflictName + ")\n\ntes-vous sr de vouloir continuer ?"
		else
			Avertissement = "Cette touche est dj utilise :\n\"" + conflictControl + "\"\n\ntes-vous sr de vouloir continuer ?"
		endIf
		ok = self.ShowMessage(Avertissement, true, "$Yes", "$No")
	endIf

	if ok 
		if option == OptionKeyCamera
			Key_Camera.SetValue(keyCode as Int)
			SetKeyMapOptionValue(OptionKeyCamera, keyCode, false)
		elseIf option == OptionKeyEcran
			Key_Ecran.SetValue(keyCode as Int)
			SetKeyMapOptionValue(OptionKeyEcran, keyCode, false)
		elseIf option == OptionKeyPause
			Key_Pause.SetValue(keyCode as Int)
			SetKeyMapOptionValue(OptionKeyPause, keyCode, false)
		;elseIf option == OptionKeyHybride
			;Key_Hybride.SetValue(keyCode as Int)
			;SetKeyMapOptionValue(OptionKeyHybride, keyCode, false)
		elseIf option == OptionKeySwitch
			Key_Switch.SetValue(keyCode as Int)
			SetKeyMapOptionValue(OptionKeySwitch, keyCode, false)
		endIf
	endIf

	TissHeadTrackQuest.ReRegisterAllKeysForce()
	TissHeadTrackQuest.OnUpdate()


EndFunction
